﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Services;
using System.Configuration;
using System.Web.Script.Serialization;
using System.Web.Script.Services;
using Hippo;

namespace Hippo.jQuery.Test
{ 
    public partial class Hippochart1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        { 
        } 

        /// <summary>
        /// 최초 그래프 데이터 조회
        /// </summary>
        /// <returns></returns>
        [WebMethod]
        public static string drawchart()
        {
            List<object> SeatList = new List<object>();

            WebForm4.wHippoChart w = new WebForm4.wHippoChart();
            w.Width = 900;
            w.Height = 400;

            SeriesList sList = new SeriesList();
            sList.ChartType = ChartType.Line;

            sList.AxisFactor.BackColor = System.Drawing.Color.Pink;

            Series sr = new Series();
            sr.Line.LineWidth = 5;
            sr.Points.Width = 10;

            for(int i = 0; i < 20; i++)
            {
                SeriesItem item = new SeriesItem();
                item.Name = i.ToString();
                item.YValue = i * 20 + 55; 
                sr.items.Add(item); 
            }

            sList.SeriesCollection.Add(sr);

            w.ImageURL = "chart/hippo43.png"; 
            w.SeriesListDictionary.Add(sList);
            w.DrawChart();

            foreach(SeriesItem item in sList.SeriesCollection[0].items)
            { 
                SeatList.Add(new
                {
                    URL =  "chart/hippo43.png?hpo=" + DateTime.Now.ToString("yyyyMMddHHmmss"),
                    ItemX = item.FigurePoint.X,
                    ItemY = item.FigurePoint.Y,
                    itemValue = item.YValue
                }); 
            }

            return (new JavaScriptSerializer().Serialize(SeatList));
        }

        /// <summary>
        /// 범위 값을 전달 받아서 그에 맞는 데이터를 다시 그립니다. 
        /// 웹일 경우 윈폼과 같이 페이지에 값을 유지하지 못하므로 마치 게시판 2번째 페이지를 호출하듯이(페이징) 여기서 디비를 재조회해야합니다.  
        /// </summary>
        /// <param name="start"></param>
        /// <param name="end"></param>
        /// <returns></returns>
        [WebMethod]
        public static string drawchartByZomm(int start, int end)
        {
            List<object> SeatList = new List<object>();

            WebForm4.wHippoChart w = new WebForm4.wHippoChart();
            w.Width = 900;
            w.Height = 400;

            SeriesList sList = new SeriesList();
            sList.ChartType = ChartType.Line;

            sList.AxisFactor.BackColor = System.Drawing.Color.Pink;

            Series sr = new Series();
            sr.Line.LineWidth = 5;
            sr.Points.Width = 10;

            // 여기서는 최최 20개 중에 해당 영역에 포함되는 것만 가져오도록 되어 있지만
            // 실제로는 디비에서 조회할때 원하는 값 리스트만 가져오도록 코드를 작성해야합니다.
            for (int i = 0; i < 20; i++)
            {
                if (i >= start && i <= end)
                {
                    SeriesItem item = new SeriesItem();
                    item.Name = i.ToString();
                    item.YValue = i * 20 + 55;
                    sr.items.Add(item);
                }
            }

            sList.SeriesCollection.Add(sr);

            w.ImageURL = "chart/hippo43.png";
            w.SeriesListDictionary.Add(sList);
            w.DrawChart(); 

            foreach (SeriesItem item in sList.SeriesCollection[0].items)
            {
                SeatList.Add(new
                {
                    URL = "chart/hippo43.png?hpo=" + DateTime.Now.ToString("yyyyMMddHHmmss"),
                    ItemX = item.FigurePoint.X,
                    ItemY = item.FigurePoint.Y,
                    itemValue = item.YValue
                });
            }

            return (new JavaScriptSerializer().Serialize(SeatList));
        }
    }
}